#ifndef VID_HEADER_H
#define VID_HEADER_H

#include <stdio.h>
#include <stdlib.h>
#include "showErrMsgBox.h"
#include <sys/types.h>
#include <sys/stat.h>

#if defined MSWIN
#define off_t __int64
#endif

#define ERR_BUFFER_LEN 10000
#define MAX_PATH 5000

class VidHeader{
public:

	char videoFileName[MAX_PATH], errMessage[ERR_BUFFER_LEN];
	FILE * videoFile;
	int width, height, num_frames, current_frame, pixmap_size, start_frame_number, end_frame_number;
	double set_brightness;
	struct stat st;
	off_t * offsets;
	unsigned long compressed_buffer_size, uncompressed_buffer_size;
	unsigned char *compressed_buffer, *uncompressed_buffer, *pixmap;
	FILE * error_outfile;

	VidHeader( char * videoFileName, FILE * error_outfile );

	bool readNextFrameFromVideoFile();

	bool readFrameFromVideoFile(int frame_number);
	
	void writePPMimage(char * fileName);

	~VidHeader();
};

#endif
