#include <mex.h>
#include "VidHeader.h"
#include <string.h>

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[]){
	VidHeader * vid_header;
	int buflen, frame_no, dims[1];
	double * buffer;

	if( mxGetNumberOfElements(prhs[0]) == 0 )
	{
		mexErrMsgTxt("Invalid Vid handle\n");
		plhs[0] = mxCreateDoubleMatrix(0, 0, mxREAL);
		return;
	}
	vid_header = (VidHeader*)mxGetPr(prhs[0]);

	frame_no = (int)mxGetScalar(prhs[1]);
	if( frame_no > vid_header -> num_frames || frame_no < 0){
		mexPrintf("vidReadMex: input frame number should be in [0, #frames] \n", frame_no, vid_header -> num_frames );
		plhs[0] = mxCreateDoubleMatrix(0, 0, mxREAL);
		return;
	}
	
	buflen = vid_header -> width * vid_header -> height * 3;
	plhs[0] = mxCreateDoubleMatrix(buflen, 1, mxREAL);
	buffer = mxGetPr(plhs[0]);

	vid_header -> readFrameFromVideoFile((int)frame_no);

	int i,j,k,l,x,y;
	int width = vid_header -> width;
	int height = vid_header -> height;
	l = 0;
	for(j=0; j<3; j++){
		for(x=0; x < width; x++){
			k = 3*x + j;
			for(y=0; y < height; y++){
				buffer[l++] = vid_header -> pixmap[k];
				k += 3*width;
			}
		}
	}
}
